 org $2000
start

	lda #8 ; open graphics 5+16
	jsr $ef9c ; openmode=$ef9c
	
;	lda 559
;	ora #1
;	sta 559

    lda #<packed
    sta source
    lda #>packed
    sta source+1

 	lda $58 ; lda #$40
 	sta dest
 	lda $59 ; lda #$BC
 	sta dest+1
	jsr unlz4

	jmp *

unlz4
                  jsr    xBIOS_GET_BYTE
                  sta    token
                  lsr @
                  lsr @
                  lsr @
                  lsr @
                  beq    read_offset
                  cmp    #$0f
                  jsr    getlength
literals          jsr    xBIOS_GET_BYTE
                  jsr    store
                  bne    literals


read_offset       jsr    xBIOS_GET_BYTE
                  tay
                  sec
                  eor    #$ff
                  adc    dest
                  sta    src
                  tya
                  php
                  jsr    xBIOS_GET_BYTE
                  plp
                  bne    not_done
                  tay
                  beq    unlz4_done
not_done          eor    #$ff
                  adc    dest+1
                  sta    src+1
                  ; c=1
                  lda    #$ff
token             equ    *-1
                  and    #$0f
                  adc    #$03                            ; 3+1=4
                  cmp    #$13
                  jsr    getLength

m1                 lda    $ffff ;@
src               equ    *-2
                  inc    src
                  bne    m2 ; @+
                  inc    src+1
m2                 jsr    store ;@
                  bne    m1 ; @-1
                  beq    unlz4


store             sta    $ffff
dest              equ    *-2
                  inc    dest
                  bne    m3 ; @+
                  inc    dest+1
m3                 dec    lenL ; @
                  bne    m4 ; @+
                  dec    lenH
m4 ; @
unlz4_done        rts


getLength_next    jsr    xBIOS_GET_BYTE
                  tay
                  clc
                  adc    #$00
lenL              equ    *-1
                  bcc    m5 ; @+
                  inc    lenH
m5                 iny ; @
getLength         sta    lenL
                  beq    getLength_next
                  tay
                  beq    m6 ; @+
                  inc    lenH
m6                 rts ;@


lenH dta 0 ;             .byte    $00

xBIOS_GET_BYTE
get_byte          lda    $ffff
source            equ    *-2
                  inc    source
                  bne    m7 ; @+
                  inc    source+1
m7                 rts ; @

packed ins "gfx.lz4",$0B ;(skip header)
 run start
